"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.twinsMiddleware = void 0;
var fs_1 = require("fs");
var path_1 = require("path");
var url_1 = require("url");
var path_to_regexp_1 = __importDefault(require("path-to-regexp"));
var pino_1 = __importDefault(require("pino"));
var logger = (0, pino_1.default)();
function twinsMiddleware() {
    return __awaiter(this, void 0, void 0, function () {
        var defs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, loadTwins(process.env.TWINS_PATH || './api_twins')];
                case 1:
                    defs = _a.sent();
                    return [2 /*return*/, function (req, res, next) {
                            var story = getStory(req);
                            var params = {
                                url: (0, url_1.parse)(req.url).pathname || '/',
                                method: req.method,
                                body: req.body,
                                query: req.query,
                            };
                            var found = findTwin(defs, __assign(__assign({}, params), story)) || findTwin(defs, __assign(__assign({}, params), { story: '_default', storyPath: undefined })) || findTwin(defs, __assign(__assign({}, params), { story: '_manual', storyPath: undefined }));
                            if (!found) {
                                logger.info(__assign(__assign(__assign({}, story), params), { msg: 'Not found' }));
                                return next();
                            }
                            Object.keys(found.replyHeaders)
                                .forEach(function (key) { return res.set(key, found.replyHeaders[key]); });
                            res.status(found.status || 200);
                            res.send(found.reply);
                        }];
            }
        });
    });
}
exports.twinsMiddleware = twinsMiddleware;
var storyPathRe = /^\[([^)]+)\]/;
function getStoryPath(name) {
    var storyPathMatch = storyPathRe.exec(name);
    if (storyPathMatch) {
        return storyPathMatch[1];
    }
}
function parseContent(content) {
    var parsed = JSON.parse(content);
    if (!parsed.method) {
        parsed.method = 'GET';
    }
    if (!parsed.status) {
        parsed.status = 200;
    }
    if (!parsed.reply) {
        parsed.reply = '';
    }
    if (!parsed.query) {
        parsed.query = {};
    }
    if (!parsed.body) {
        parsed.body = {};
    }
    if (!parsed.replyHeaders) {
        parsed.replyHeaders = {};
    }
    parsed.urlRegex = (0, path_to_regexp_1.default)(parsed.url);
    return parsed;
}
function loadTwins(dir) {
    return __awaiter(this, void 0, void 0, function () {
        var all, dirs, dirsFiles, flat, withFiles;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs_1.promises.readdir(dir, { withFileTypes: true })];
                case 1:
                    all = _a.sent();
                    dirs = all.filter(function (dirent) { return dirent.isDirectory(); });
                    return [4 /*yield*/, Promise.all(dirs.map(function (curr) {
                            return fs_1.promises.readdir((0, path_1.join)(dir, curr.name));
                        }))];
                case 2:
                    dirsFiles = _a.sent();
                    flat = dirs.reduce(function (sum, curr, idx) {
                        var story = curr.name;
                        return __spreadArray(__spreadArray([], __read(sum), false), __read(dirsFiles[idx].map(function (file) { return ({ story: story, file: file, storyPath: getStoryPath(file) }); })), false);
                    }, []);
                    return [4 /*yield*/, Promise.all(flat.map(function (cur) { return __awaiter(_this, void 0, void 0, function () {
                            var content;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, fs_1.promises.readFile((0, path_1.join)(dir, cur.story, cur.file), 'utf8')];
                                    case 1:
                                        content = _a.sent();
                                        logger.info({ story: cur.story, loaded: cur.file });
                                        return [2 /*return*/, __assign(__assign({}, cur), parseContent(content))];
                                }
                            });
                        }); }))];
                case 3:
                    withFiles = _a.sent();
                    return [2 /*return*/, withFiles];
            }
        });
    });
}
function findTwin(list, search) {
    var found = list.find(function (item) {
        return (item.urlRegex.exec(search.url) &&
            search.method === item.method &&
            search.story === item.story &&
            search.storyPath === item.storyPath &&
            match(search.body, item.body) &&
            match(search.query, item.query));
    });
    return found;
}
var TwinsCookieOrQuery = 'api_twin';
var TwinsHeader = 'x-api-twin';
function getStory(req) {
    var cookie = req.cookies[TwinsCookieOrQuery];
    var query = req.query[TwinsCookieOrQuery];
    var header = req.get(TwinsHeader);
    var twin = header || query || cookie;
    if (!twin) {
        return {
            story: undefined,
            storyPath: undefined,
            uuid: undefined,
        };
    }
    var _a = __read(twin.split(':'), 3), story = _a[0], storyPath = _a[1], uuid = _a[2];
    return {
        story: story,
        storyPath: storyPath,
        uuid: uuid,
    };
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function match(check, sample) {
    if (typeof check !== typeof sample) {
        return false;
    }
    if (typeof sample === 'object' && sample) {
        return !Object.keys(sample).some(function (key) {
            return !match(check[key], sample[key]);
        });
    }
    return check === sample;
}
//# sourceMappingURL=twins.js.map